﻿;Macro para fazer textura de madeira
;Realizada pelo aluno João Dimas Fragoso, 20151312, MI Arquitetura 2CD
;Sistemas de Representação Digital em Arquitetura, professor Vitor Correia
;Faculdade de Arquitetura - Universidade de Lisboa

;o objetivo da concretização desta macro é tornar a criação da textura da madeira mais fácil e rápida

;nome da função
(defun c:madeira()

;seleção de 3 pontos:
;ponto 1 - define o ponto inicial
(setq p1 (getpoint "\n Ponto inferio esquerdo"))

;ponto 2 - define a altura
(setq p2 (getpoint "\n Ponto superior esquerdo"))

;ponto 3 - define o comprimento
(setq p3 (getpoint "\n Ponto superior direito"))

;ponto 4 - termina a forma da área
(setq p4 (getpoint "\n Ponto inferior direito"))

;função com coordenadas polares:
;definimos um ponto de refência ao qual atribiuimos um determinado ângulo e comprimento
;utilização de direções já conhecidas para os ângulos e de medidas já conhecidas para as distâncias
(setq p5 (polar p1 (angle p1 p3) (* (distance p1 p2) 0.5)))
(setq p6 (polar p5 (angle p2 p3) (* (distance p2 p3) 0.14)))
(setq p7 (polar p6 (angle p2 p3) (* (distance p2 p3) 0.14)))
(setq p8 (polar p7 (angle p1 p3) (* (distance p2 p3) 0.14)))
(setq p9 (polar p8 (angle p2 p3) (* (distance p2 p3) 0.14)))
(setq p10 (polar p9 (angle p1 p3) (* (distance p2 p3) 0.14)))

;ligar os pontos através de uma linha curva
(command "spline" p1 p5 p6 p7 p8 p9 p10 p4 "" "" "")

;reproduzir o veio da madeira para fazer a textura
(command "offset" (setq a (getreal "\n medida do offset: ")) "last" "")
)